﻿using igGridFilteringDropDown.Models;
using Infragistics.Web.Mvc;
using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace igGridFilteringDropDown.Controllers
{
	public class HomeController : Controller
	{         
         public ActionResult Index()
          {
              return View();                 
          }
        
         public JsonResult GetData()
         {
             IEnumerable<Product> product = Product.GetProductData().Take(200);
             IQueryable data = product.AsQueryable();
             int totalCount = data.Count();
             if (Request.QueryString["$top"] != null && Request.QueryString["$skip"] != null)
             {
                 data = ApplyPaging(Request.QueryString, data);
             }

             JsonResult result = new JsonResult();
             result.JsonRequestBehavior = JsonRequestBehavior.AllowGet;
             result.Data = new { Records = data, TotalRecordsCount = totalCount };

             return result;
         }

         private IQueryable ApplyPaging(NameValueCollection queryString, IQueryable data)
         {
             int recCount = Convert.ToInt32(queryString["$top"]);
             int startIndex = Convert.ToInt32(queryString["$skip"]);

             data = data.Skip(startIndex).Take(recCount);
             return data;
         }
        
         [GridDataSourceAction]
         public ActionResult GetDatas()
         {
             var prod = GetData();
             return View("Index", prod);
         }
     }
}